/*  INPUT.PL  */
/*  Shelved on the 20th April, 1988.  */


/*
    This file defines routines which read a sentence as a list of words,
    using recursion and the standard trick of keeping the next character
    in  a  separate  variable.  Note   that  they  call  'name2'  -  see
    NAME.PL. They also assume the ASCII character set.
                    Jocelyn Paine.
*/


/*  INPUT  -  A  METHOD  OF  READING  SENTENCES  ENTERED  */
/*    */
/* nb. name2 */


enter_sentence(Without_punc) :-
       enter_phrase(With_punc),
       last_word(Punc),
       append(Without_punc,[Punc],With_punc).


enter_phrase([First_word|Rest_sentence]):-
       nl,write('Type your sentence  '),
/*  bell, */
        nl,nl,
    write('         ==>'),
       get0(First_char),
       get_word(First_char,First_word,Next_char),
       rest_sentence(First_word,Next_char,Rest_sentence).

get_word(First_char,Word,Next_char) :-
       punctuation(First_char),
       !,
       name2(Word,[First_char]),
       get0(Next_char).

get_word(First_char,Word,Char_after) :-
       low_case(First_char,Low_char),
       !,
       get0(Next_char),
       rest_word(Next_char,Rest_chars,Char_after),
       name2(Word,[Low_char|Rest_chars]).

get_word(First_char,Word,Char_after) :-
       get0(Next_first_char),
       get_word(Next_first_char,Word,Char_after).

rest_sentence(Word,_,[]) :-
       last_word(Word),
       !.

rest_sentence(Word,Next_char,[Next_word|Rest_words]) :-
       get_word(Next_char,Next_word,Char_after),
       rest_sentence(Next_word,Char_after,Rest_words).

rest_word(Apostrophe,[Apostrophe],Char_after) :-
       apostrophe(Apostrophe),
       !,
       get0(Char_after).

rest_word(Char,[Low_char|Rest_chars],Char_after) :-
       low_case(Char,Low_char),
       !,
       get0(Next_char),
       rest_word(Next_char,Rest_chars,Char_after).

rest_word(Char_after,[],Char_after).

/* set up relations here */

punctuation(33). /* (!) */
punctuation(63). /* (?) */
punctuation(46). /* (.) */
apostrophe(39).  /* (') */

low_case(C,C) :- /* small letters */
       (C>96),
       (C<123).

low_case(C,Lower_case) :- /* capital letters */
       (C>64),
       (C<91),
       (Lower_case is (C + 32)).

low_case(C,C) :- /* digits */
       (C>47),
       (C<58).

low_case(39,39). /* (') */

low_case(45,45). /* (-) */

last_word('.').
last_word('!').
last_word('?').
last_word(".").
last_word("!").
last_word("?").
